﻿using ProjectPlane.Drawnings;

namespace ProjectPlane.CollectionGenericObjects;

public class Marina : AbstractCompany
{
    public Marina(int picWidth, int picHeight, ICollectionGenericObjects<DrawningShip> collection) : base(picWidth, picHeight, collection)
    {
    }

    protected override void DrawBackgound(Graphics g)
    {
        Pen pen = new(Color.Black, 2);

        for (int i = 0; i < _pictureHeight / _placeSizeHeight; i++)
        {
            int y = _placeSizeHeight;
            y *= i;

            for (int j = 0; j <= _pictureWidth / _placeSizeWidth; j++)
            {
                int x = _placeSizeWidth;
                x *= j;

                g.DrawLine(pen, x, y, x + _placeSizeWidth / 2, y);
                g.DrawLine(pen, x, y + _placeSizeHeight - 10, x + _placeSizeWidth / 2, y + _placeSizeHeight - 10);
            }

        }
    }

    protected override void SetObjectsPosition()
    {
        int n = _pictureWidth / _placeSizeWidth;
        int m = 0;

        for (int i = 0; i < (_collection?.Count ?? 0); i++)
        {
            if (_collection?.Get(i) != null)
            {
                int x = _placeSizeWidth * n;
                int y = (10 + _placeSizeHeight * (_pictureHeight / _placeSizeHeight - 1)) - _placeSizeHeight * m;

                _collection?.Get(i)?.SetPictureSize(_pictureWidth, _pictureHeight);
                _collection?.Get(i)?.SetPosition(x, y);
            }

            if (n > 0)
                n--;
            else
            {
                n = _pictureWidth / _placeSizeWidth;
                m++;
            }
        }
    }
}
