﻿using ProjectPlane.Entities;

namespace ProjectPlane.Drawnings;

public class DrawCont : DrawningShip
{
    public DrawCont(int speed, double weight, Color shipColor, Color containerColor, bool container, bool crane) : base(160, 90)
    {
        EntityShip = new EntityContainer(speed, weight, shipColor, containerColor, container, crane);
    }

    public override void DrawTransport(Graphics g)
    {
        if (EntityShip == null || !_StartPosX.HasValue || !_StartPosY.HasValue || EntityShip is not EntityContainer container)
        {
            return;
        }

        Pen pen = new(Color.Black);
        Brush ContainerBrush = new SolidBrush(container.ContainerColor);

        // отрисовка контейнера
        if (container.Container)
        {
            g.DrawRectangle(pen, _StartPosX.Value + 80, _StartPosY.Value, 60, 40);
            g.FillRectangle(ContainerBrush, _StartPosX.Value + 81, _StartPosY.Value + 1, 59, 39);
        }

        _StartPosY += 40;
        base.DrawTransport(g);
        _StartPosY -= 40;

        //отрисовка крана
        if (container.Crane)
        {
            g.DrawLine(pen, _StartPosX.Value + 30, _StartPosY.Value + 50, _StartPosX.Value + 30, _StartPosY.Value + 70);
            g.DrawLine(pen, _StartPosX.Value + 20, _StartPosY.Value + 60, _StartPosX.Value + 40, _StartPosY.Value + 60);
        }
    }

}
